// Generated by CoffeeScript 1.12.6
(function() {
  var ceri;

  ceri = require("ceri/lib/wrapper");

  module.exports = ceri({
    mixins: [require("ceri/lib/props"), require("ceri/lib/computed")],
    props: {
      target: {
        type: String
      }
    },
    computed: {
      cTarget: {
        cbs: function(target) {
          var child, j, len, ref1, results;
          ref1 = this._children;
          results = [];
          for (j = 0, len = ref1.length; j < len; j++) {
            child = ref1[j];
            results.push(target.appendChild(child));
          }
          return results;
        },
        get: function() {
          var selector, tmp;
          if (this.target) {
            selector = this.target;
            tmp = document.querySelector(selector);
            if(process.env.NODE_ENV!=='production' && tmp == null){console.warn('no element found with ' + selector)};
            if (tmp != null) {
              return tmp;
            }
          }
          return document.body;
        }
      }
    },
    created: function() {
      return this._children = [];
    },
    connectedCallback: function() {
      var child, j, len, ref1;
      if (this._isFirstConnect) {
        ref1 = this.children;
        for (j = 0, len = ref1.length; j < len; j++) {
          child = ref1[j];
          this._children.push(child);
          this.removeChild(child);
        }
        this.appendChild = (function(_this) {
          return function(child) {
            _this._children.push(child);
            return _this.cTarget.appendChild(child);
          };
        })(this);
        this.removeChild = (function(_this) {
          return function(child) {
            var c, i, index, k, len1, ref2;
            index = -1;
            ref2 = _this._children;
            for (i = k = 0, len1 = ref2.length; k < len1; i = ++k) {
              c = ref2[i];
              if (c === child) {
                index = i;
                break;
              }
            }
            if (index > -1) {
              _this._children.splice(index, 1);
              return _this.cTarget.removeChild(child);
            }
          };
        })(this);
        this.insertBefore = (function(_this) {
          return function(child, ref) {
            var c, i, k, len1, ref2;
            ref2 = _this._children;
            for (i = k = 0, len1 = ref2.length; k < len1; i = ++k) {
              c = ref2[i];
              if (c === ref) {
                _this._children.splice(i, 0, child);
                break;
              }
            }
            return _this.cTarget.insertBefore(child, ref);
          };
        })(this);
        return this.replaceChild = (function(_this) {
          return function(child, ref) {
            var c, i, k, len1, ref2;
            ref2 = _this._children;
            for (i = k = 0, len1 = ref2.length; k < len1; i = ++k) {
              c = ref2[i];
              if (c === ref) {
                _this._children.splice(i, 1, child);
                break;
              }
            }
            return _this.cTarget.replaceChild(child, ref);
          };
        })(this);
      } else {
        return this.$computed.getNotifyCb({
          path: "cTarget"
        })();
      }
    },
    disconnectedCallback: function() {
      var child, j, len, ref1, results;
      ref1 = this._children;
      results = [];
      for (j = 0, len = ref1.length; j < len; j++) {
        child = ref1[j];
        results.push(child.remove());
      }
      return results;
    }
  });

}).call(this);
